#ifndef _H_502A3ACA628D71C19644BFDE4D787091_AnalogIn__H_
#define _H_502A3ACA628D71C19644BFDE4D787091_AnalogIn__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace neobotix_usboard_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  AnalogIn_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet command_;
                ::DDS::Octet analog_data_ch4_low_byte_;
                ::DDS::Octet analog_data_ch4_high_bits_;
                ::DDS::Octet analog_data_ch3_low_byte_;
                ::DDS::Octet analog_data_ch3_high_bits_;
                ::DDS::Octet analog_data_ch2_low_byte_;
                ::DDS::Octet analog_data_ch2_high_bits_;
                ::DDS::Octet analog_data_ch1_low_byte_;
                ::DDS::Octet analog_data_ch1_high_bits_;
            };

            typedef DDS_DCPSStruct_var<AnalogIn_> AnalogIn__var;
            typedef DDS_DCPSStruct_out < AnalogIn_> AnalogIn__out;

        }

    }

}

#endif /* _H_502A3ACA628D71C19644BFDE4D787091_AnalogIn__H_ */
