#ifndef _H_502A3ACA628D71C19644BFDE4D787091_AnalogIn_DCPS_H_
#define _H_502A3ACA628D71C19644BFDE4D787091_AnalogIn_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AnalogIn_.h"


namespace neobotix_usboard_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class AnalogIn_TypeSupportInterface;

            typedef AnalogIn_TypeSupportInterface * AnalogIn_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AnalogIn_TypeSupportInterface> AnalogIn_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AnalogIn_TypeSupportInterface> AnalogIn_TypeSupportInterface_out;


            class AnalogIn_DataWriter;

            typedef AnalogIn_DataWriter * AnalogIn_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AnalogIn_DataWriter> AnalogIn_DataWriter_var;
            typedef DDS_DCPSInterface_out < AnalogIn_DataWriter> AnalogIn_DataWriter_out;


            class AnalogIn_DataReader;

            typedef AnalogIn_DataReader * AnalogIn_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AnalogIn_DataReader> AnalogIn_DataReader_var;
            typedef DDS_DCPSInterface_out < AnalogIn_DataReader> AnalogIn_DataReader_out;


            class AnalogIn_DataReaderView;

            typedef AnalogIn_DataReaderView * AnalogIn_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AnalogIn_DataReaderView> AnalogIn_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AnalogIn_DataReaderView> AnalogIn_DataReaderView_out;

            struct AnalogIn_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AnalogIn_, struct AnalogIn_Seq_uniq_> AnalogIn_Seq;
            typedef DDS_DCPSSequence_var < AnalogIn_Seq> AnalogIn_Seq_var;
            typedef DDS_DCPSSequence_out < AnalogIn_Seq> AnalogIn_Seq_out;

            class  AnalogIn_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AnalogIn_TypeSupportInterface_ptr _ptr_type;
                typedef AnalogIn_TypeSupportInterface_var _var_type;

                static AnalogIn_TypeSupportInterface_ptr _duplicate (AnalogIn_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AnalogIn_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AnalogIn_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AnalogIn_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AnalogIn_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AnalogIn_TypeSupportInterface () {};
                ~AnalogIn_TypeSupportInterface () {};
            private:
                AnalogIn_TypeSupportInterface (const AnalogIn_TypeSupportInterface &);
                AnalogIn_TypeSupportInterface & operator = (const AnalogIn_TypeSupportInterface &);
            };

            class  AnalogIn_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AnalogIn_DataWriter_ptr _ptr_type;
                typedef AnalogIn_DataWriter_var _var_type;

                static AnalogIn_DataWriter_ptr _duplicate (AnalogIn_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AnalogIn_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AnalogIn_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AnalogIn_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AnalogIn_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AnalogIn_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AnalogIn_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AnalogIn_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AnalogIn_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AnalogIn_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AnalogIn_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AnalogIn_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AnalogIn_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AnalogIn_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AnalogIn_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AnalogIn_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AnalogIn_& instance_data) = 0;

            protected:
                AnalogIn_DataWriter () {};
                ~AnalogIn_DataWriter () {};
            private:
                AnalogIn_DataWriter (const AnalogIn_DataWriter &);
                AnalogIn_DataWriter & operator = (const AnalogIn_DataWriter &);
            };

            class  AnalogIn_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AnalogIn_DataReader_ptr _ptr_type;
                typedef AnalogIn_DataReader_var _var_type;

                static AnalogIn_DataReader_ptr _duplicate (AnalogIn_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AnalogIn_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AnalogIn_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AnalogIn_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AnalogIn_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AnalogIn_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AnalogIn_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AnalogIn_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AnalogIn_& instance) = 0;

            protected:
                AnalogIn_DataReader () {};
                ~AnalogIn_DataReader () {};
            private:
                AnalogIn_DataReader (const AnalogIn_DataReader &);
                AnalogIn_DataReader & operator = (const AnalogIn_DataReader &);
            };

            class  AnalogIn_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AnalogIn_DataReaderView_ptr _ptr_type;
                typedef AnalogIn_DataReaderView_var _var_type;

                static AnalogIn_DataReaderView_ptr _duplicate (AnalogIn_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AnalogIn_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AnalogIn_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AnalogIn_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AnalogIn_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AnalogIn_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AnalogIn_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AnalogIn_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AnalogIn_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AnalogIn_& instance) = 0;

            protected:
                AnalogIn_DataReaderView () {};
                ~AnalogIn_DataReaderView () {};
            private:
                AnalogIn_DataReaderView (const AnalogIn_DataReaderView &);
                AnalogIn_DataReaderView & operator = (const AnalogIn_DataReaderView &);
            };
        }

    }

}

#endif
