#ifndef _H_99BCDA694C145780A48BDE763C532281_AnsToCmdConnect_DCPS_H_
#define _H_99BCDA694C145780A48BDE763C532281_AnsToCmdConnect_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AnsToCmdConnect_.h"


namespace neobotix_usboard_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class AnsToCmdConnect_TypeSupportInterface;

            typedef AnsToCmdConnect_TypeSupportInterface * AnsToCmdConnect_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AnsToCmdConnect_TypeSupportInterface> AnsToCmdConnect_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AnsToCmdConnect_TypeSupportInterface> AnsToCmdConnect_TypeSupportInterface_out;


            class AnsToCmdConnect_DataWriter;

            typedef AnsToCmdConnect_DataWriter * AnsToCmdConnect_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AnsToCmdConnect_DataWriter> AnsToCmdConnect_DataWriter_var;
            typedef DDS_DCPSInterface_out < AnsToCmdConnect_DataWriter> AnsToCmdConnect_DataWriter_out;


            class AnsToCmdConnect_DataReader;

            typedef AnsToCmdConnect_DataReader * AnsToCmdConnect_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AnsToCmdConnect_DataReader> AnsToCmdConnect_DataReader_var;
            typedef DDS_DCPSInterface_out < AnsToCmdConnect_DataReader> AnsToCmdConnect_DataReader_out;


            class AnsToCmdConnect_DataReaderView;

            typedef AnsToCmdConnect_DataReaderView * AnsToCmdConnect_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AnsToCmdConnect_DataReaderView> AnsToCmdConnect_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AnsToCmdConnect_DataReaderView> AnsToCmdConnect_DataReaderView_out;

            struct AnsToCmdConnect_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AnsToCmdConnect_, struct AnsToCmdConnect_Seq_uniq_> AnsToCmdConnect_Seq;
            typedef DDS_DCPSSequence_var < AnsToCmdConnect_Seq> AnsToCmdConnect_Seq_var;
            typedef DDS_DCPSSequence_out < AnsToCmdConnect_Seq> AnsToCmdConnect_Seq_out;

            class  AnsToCmdConnect_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AnsToCmdConnect_TypeSupportInterface_ptr _ptr_type;
                typedef AnsToCmdConnect_TypeSupportInterface_var _var_type;

                static AnsToCmdConnect_TypeSupportInterface_ptr _duplicate (AnsToCmdConnect_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AnsToCmdConnect_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AnsToCmdConnect_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AnsToCmdConnect_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AnsToCmdConnect_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AnsToCmdConnect_TypeSupportInterface () {};
                ~AnsToCmdConnect_TypeSupportInterface () {};
            private:
                AnsToCmdConnect_TypeSupportInterface (const AnsToCmdConnect_TypeSupportInterface &);
                AnsToCmdConnect_TypeSupportInterface & operator = (const AnsToCmdConnect_TypeSupportInterface &);
            };

            class  AnsToCmdConnect_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AnsToCmdConnect_DataWriter_ptr _ptr_type;
                typedef AnsToCmdConnect_DataWriter_var _var_type;

                static AnsToCmdConnect_DataWriter_ptr _duplicate (AnsToCmdConnect_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AnsToCmdConnect_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AnsToCmdConnect_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AnsToCmdConnect_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AnsToCmdConnect_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AnsToCmdConnect_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AnsToCmdConnect_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AnsToCmdConnect_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AnsToCmdConnect_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AnsToCmdConnect_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AnsToCmdConnect_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AnsToCmdConnect_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AnsToCmdConnect_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AnsToCmdConnect_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AnsToCmdConnect_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AnsToCmdConnect_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AnsToCmdConnect_& instance_data) = 0;

            protected:
                AnsToCmdConnect_DataWriter () {};
                ~AnsToCmdConnect_DataWriter () {};
            private:
                AnsToCmdConnect_DataWriter (const AnsToCmdConnect_DataWriter &);
                AnsToCmdConnect_DataWriter & operator = (const AnsToCmdConnect_DataWriter &);
            };

            class  AnsToCmdConnect_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AnsToCmdConnect_DataReader_ptr _ptr_type;
                typedef AnsToCmdConnect_DataReader_var _var_type;

                static AnsToCmdConnect_DataReader_ptr _duplicate (AnsToCmdConnect_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AnsToCmdConnect_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AnsToCmdConnect_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AnsToCmdConnect_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AnsToCmdConnect_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AnsToCmdConnect_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AnsToCmdConnect_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AnsToCmdConnect_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AnsToCmdConnect_& instance) = 0;

            protected:
                AnsToCmdConnect_DataReader () {};
                ~AnsToCmdConnect_DataReader () {};
            private:
                AnsToCmdConnect_DataReader (const AnsToCmdConnect_DataReader &);
                AnsToCmdConnect_DataReader & operator = (const AnsToCmdConnect_DataReader &);
            };

            class  AnsToCmdConnect_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AnsToCmdConnect_DataReaderView_ptr _ptr_type;
                typedef AnsToCmdConnect_DataReaderView_var _var_type;

                static AnsToCmdConnect_DataReaderView_ptr _duplicate (AnsToCmdConnect_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AnsToCmdConnect_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AnsToCmdConnect_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AnsToCmdConnect_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AnsToCmdConnect_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AnsToCmdConnect_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AnsToCmdConnect_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AnsToCmdConnect_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AnsToCmdConnect_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AnsToCmdConnect_& instance) = 0;

            protected:
                AnsToCmdConnect_DataReaderView () {};
                ~AnsToCmdConnect_DataReaderView () {};
            private:
                AnsToCmdConnect_DataReaderView (const AnsToCmdConnect_DataReaderView &);
                AnsToCmdConnect_DataReaderView & operator = (const AnsToCmdConnect_DataReaderView &);
            };
        }

    }

}

#endif
